Index: /boa/src/main/java/geniusweb/boa/BoaState.java
===================================================================
--- /boa/src/main/java/geniusweb/boa/BoaState.java	(revision 33)
+++ /boa/src/main/java/geniusweb/boa/BoaState.java	(revision 34)
@@ -216,4 +216,5 @@
 		try {
 			newmodel = opponentModelClass.newInstance()
+					.with(settings.getParameters())
 					.with(profile.getDomain(), profile.getReservationBid());
 		} catch (Exception e) {
Index: /collectparties.sh
===================================================================
--- /collectparties.sh	(revision 33)
+++ /collectparties.sh	(revision 34)
@@ -7,5 +7,5 @@
 rm -rf collectedparties
 mkdir collectedparties
-VERSION=2.0.0
+VERSION=2.0.1
 
 cp "exampleparties/anac2019/agentgg/target/agentgg-${VERSION}-jar-with-dependencies.jar" collectedparties
Index: /events/src/main/java/geniusweb/actions/Vote.java
===================================================================
--- /events/src/main/java/geniusweb/actions/Vote.java	(revision 33)
+++ /events/src/main/java/geniusweb/actions/Vote.java	(revision 34)
@@ -15,5 +15,5 @@
 
 	/**
-	 * @param id       the {@link PartyId} that does the action
+	 * @param actor    the {@link PartyId} that does the action
 	 * @param bid      the bid that is voted on
 	 * @param minPower the minimum power this bid must get in order for the vote
@@ -26,8 +26,9 @@
 	 */
 	@JsonCreator
-	public Vote(@JsonProperty("actor") PartyId id, @JsonProperty("bid") Bid bid,
+	public Vote(@JsonProperty("actor") PartyId actor,
+			@JsonProperty("bid") Bid bid,
 			@JsonProperty("minPower") Integer minPower,
 			@JsonProperty("maxPower") Integer maxPower) {
-		super(id, bid);
+		super(actor, bid);
 		this.minPower = minPower;
 		this.maxPower = maxPower;
Index: /events/src/main/java/geniusweb/actions/Votes.java
===================================================================
--- /events/src/main/java/geniusweb/actions/Votes.java	(revision 33)
+++ /events/src/main/java/geniusweb/actions/Votes.java	(revision 34)
@@ -2,9 +2,8 @@
 
 import java.util.Collections;
-import java.util.Map;
-import java.util.Map.Entry;
-import java.util.Optional;
+import java.util.HashSet;
+import java.util.LinkedList;
+import java.util.List;
 import java.util.Set;
-import java.util.stream.Collectors;
 
 import com.fasterxml.jackson.annotation.JsonCreator;
@@ -22,33 +21,30 @@
 	/**
 	 * 
-	 * @param id    party id
+	 * @param actor party id
 	 * @param votes the {@link Vote}s that the party can agree on, if the
 	 *              condition of the Vote holds. Every {@link Vote#getActor()}
-	 *              should equal the id
+	 *              should equal the id. There may be at most 1 vote per
+	 *              {@link Bid}.
 	 */
 	@JsonCreator
-	public Votes(@JsonProperty("actor") PartyId id,
+	public Votes(@JsonProperty("actor") PartyId actor,
 			@JsonProperty("votes") Set<Vote> votes) {
-		super(id);
-		this.votes = votes;
+		super(actor);
+		this.votes = new HashSet<>(votes);
 		if (votes == null)
 			throw new NullPointerException("votes must be not null");
+
+		List<Bid> votedBids = new LinkedList<>();
 		for (Vote vote : votes) {
-			if (!vote.getActor().equals(id)) {
+			if (!vote.getActor().equals(actor))
 				throw new IllegalArgumentException("All votes must come from "
-						+ id + " but found " + vote);
-			}
+						+ actor + " but found " + vote);
+
+			Bid bid = vote.getBid();
+			if (votedBids.contains(bid))
+				throw new IllegalArgumentException(
+						"Votes contains multiple Vote's for " + bid);
+			votedBids.add(bid);
 		}
-		// check for duplicate Vote's, possibly with different powers
-		Map<Bid, Long> counts = votes.stream().map(vote -> vote.getBid())
-				.collect(Collectors.groupingBy(bid -> bid,
-						Collectors.counting()));
-		Optional<Entry<Bid, Long>> nonunique = counts.entrySet().stream()
-				.filter(entry -> entry.getValue() > 1).findAny();
-		if (nonunique.isPresent())
-			throw new IllegalArgumentException(
-					"Votes contains multiple Vote's for "
-							+ nonunique.get().getKey());
-
 	}
 
Index: /events/src/main/java/geniusweb/events/CurrentState.java
===================================================================
--- /events/src/main/java/geniusweb/events/CurrentState.java	(revision 33)
+++ /events/src/main/java/geniusweb/events/CurrentState.java	(revision 34)
@@ -20,4 +20,9 @@
  */
 public abstract class CurrentState extends ProtocolEvent {
-	// all should implement NegoState getState();
+	public CurrentState() {
+	}
+
+	public CurrentState(Long now) {
+		super(now);
+	}
 }
Index: /events/src/main/java/geniusweb/inform/OptIn.java
===================================================================
--- /events/src/main/java/geniusweb/inform/OptIn.java	(revision 33)
+++ /events/src/main/java/geniusweb/inform/OptIn.java	(revision 34)
@@ -2,9 +2,6 @@
 
 import java.util.Collections;
+import java.util.LinkedList;
 import java.util.List;
-import java.util.Map;
-import java.util.Map.Entry;
-import java.util.Optional;
-import java.util.stream.Collectors;
 
 import com.fasterxml.jackson.annotation.JsonCreator;
@@ -28,14 +25,12 @@
 		this.votes = votes;
 
-		Map<PartyId, Long> counts = votes.stream().map(vote -> vote.getActor())
-				.collect(Collectors.groupingBy(actor -> actor,
-						Collectors.counting()));
-		Optional<Entry<PartyId, Long>> nonunique = counts.entrySet().stream()
-				.filter(entry -> entry.getValue() > 1).findAny();
-		if (nonunique.isPresent())
-			throw new IllegalArgumentException(
-					"OptIn contains multiple Votes for party "
-							+ nonunique.get().getKey());
-
+		List<PartyId> partyVotes = new LinkedList<>();
+		for (Votes vote : votes) {
+			PartyId party = vote.getActor();
+			if (partyVotes.contains(party))
+				throw new IllegalArgumentException(
+						"OptIn contains multiple Votes for party " + party);
+			partyVotes.add(party);
+		}
 	}
 
Index: /events/src/main/java/geniusweb/inform/Voting.java
===================================================================
--- /events/src/main/java/geniusweb/inform/Voting.java	(revision 33)
+++ /events/src/main/java/geniusweb/inform/Voting.java	(revision 34)
@@ -27,8 +27,13 @@
 
 	/**
-	 * @return list of bids to be voted on
+	 * @return list of offers to be voted on
 	 */
+	public List<Offer> getOffers() {
+		return Collections.unmodifiableList(offers);
+	}
+
+	@Deprecated
 	public List<Offer> getBids() {
-		return Collections.unmodifiableList(offers);
+		return getOffers();
 	}
 
Index: /exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java
===================================================================
--- /exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java	(revision 33)
+++ /exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java	(revision 34)
@@ -93,6 +93,6 @@
 					getConnection().send(new LearningDone(me));
 				} else {
-					this.profileint = ProfileConnectionFactory.create(
-							sett.getProfile().getURI(), getReporter());
+					this.profileint = ProfileConnectionFactory
+							.create(sett.getProfile().getURI(), getReporter());
 				}
 			} else if (info instanceof ActionDone) {
@@ -242,5 +242,5 @@
 				: Integer.MAX_VALUE;
 
-		Set<Vote> votes = voting.getBids().stream().distinct()
+		Set<Vote> votes = voting.getOffers().stream().distinct()
 				.filter(offer -> isGood(offer.getBid()))
 				.map(offer -> new Vote(me, offer.getBid(), minpower, maxpower))
@@ -262,5 +262,5 @@
 				: Integer.MAX_VALUE;
 
-		List<Bid> goodbids = voting.getBids().stream().distinct()
+		List<Bid> goodbids = voting.getOffers().stream().distinct()
 				.filter(offer -> isGood(offer.getBid()))
 				.map(offer -> offer.getBid()).collect(Collectors.toList());
Index: /exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/TimeDependentParty.java
===================================================================
--- /exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/TimeDependentParty.java	(revision 33)
+++ /exampleparties/timedependentparty/src/main/java/geniusweb/exampleparties/timedependentparty/TimeDependentParty.java	(revision 34)
@@ -298,5 +298,5 @@
 				: Integer.MAX_VALUE;
 
-		Set<Vote> votes = voting.getBids().stream().distinct()
+		Set<Vote> votes = voting.getOffers().stream().distinct()
 				.filter(offer -> isGood(offer.getBid()))
 				.map(offer -> new Vote(me, offer.getBid(), minpower, maxpower))
Index: /issuevalue/src/test/java/geniusweb/issuevalue/DiscreteValueSetTest.java
===================================================================
--- /issuevalue/src/test/java/geniusweb/issuevalue/DiscreteValueSetTest.java	(revision 33)
+++ /issuevalue/src/test/java/geniusweb/issuevalue/DiscreteValueSetTest.java	(revision 34)
@@ -39,8 +39,8 @@
 	// parsed as discrete values.
 	private static final String discretenumbers = "{\"values\":[\"0\",\"1\"]}";
+	private static final ObjectMapper jackson = new ObjectMapper();
 
 	@Test
 	public void testSerialize() throws JsonProcessingException {
-		ObjectMapper jackson = new ObjectMapper();
 
 		String json = jackson.writeValueAsString(set);
@@ -52,5 +52,4 @@
 	public void testDeserialize()
 			throws JsonParseException, JsonMappingException, IOException {
-		ObjectMapper jackson = new ObjectMapper();
 		DiscreteValueSet p = jackson.readValue(asString,
 				DiscreteValueSet.class);
@@ -62,5 +61,4 @@
 	public void testDeserializeNumberValues()
 			throws JsonParseException, JsonMappingException, IOException {
-		ObjectMapper jackson = new ObjectMapper();
 		DiscreteValueSet p = jackson.readValue(discretenumbers,
 				DiscreteValueSet.class);
Index: /issuevalue/src/test/java/geniusweb/issuevalue/DiscreteValueTest.java
===================================================================
--- /issuevalue/src/test/java/geniusweb/issuevalue/DiscreteValueTest.java	(revision 33)
+++ /issuevalue/src/test/java/geniusweb/issuevalue/DiscreteValueTest.java	(revision 34)
@@ -13,17 +13,15 @@
 import com.fasterxml.jackson.databind.ObjectMapper;
 
-import geniusweb.issuevalue.DiscreteValue;
-import geniusweb.issuevalue.Value;
 import tudelft.utilities.junit.GeneralTests;
 
 public class DiscreteValueTest extends GeneralTests<DiscreteValue> {
-	private DiscreteValue value = new DiscreteValue("a");
-	private DiscreteValue value1 = new DiscreteValue("a");
-	private DiscreteValue valueb = new DiscreteValue("b");
-	private String serialized = "\"a\"";
+	private final DiscreteValue value = new DiscreteValue("a");
+	private final DiscreteValue value1 = new DiscreteValue("a");
+	private final DiscreteValue valueb = new DiscreteValue("b");
+	private final String serialized = "\"a\"";
+	private static final ObjectMapper jackson = new ObjectMapper();
 
 	@Test
 	public void testSerialize() throws JsonProcessingException {
-		ObjectMapper jackson = new ObjectMapper();
 		assertEquals(serialized, jackson.writeValueAsString(value));
 	}
@@ -31,5 +29,4 @@
 	@Test
 	public void testDeserialize() throws IOException {
-		ObjectMapper jackson = new ObjectMapper();
 		assertEquals(value, jackson.readValue(serialized, DiscreteValue.class));
 	}
@@ -37,5 +34,4 @@
 	@Test
 	public void testDeserializeFromValue() throws IOException {
-		ObjectMapper jackson = new ObjectMapper();
 		assertEquals(value, jackson.readValue(serialized, Value.class));
 	}
@@ -43,5 +39,4 @@
 	@Override
 	public List<List<DiscreteValue>> getGeneralTestData() {
-
 		List<List<DiscreteValue>> list = new LinkedList<>();
 		list.add(Arrays.asList(value, value1));
Index: /issuevalue/src/test/java/geniusweb/issuevalue/NumberValueTest.java
===================================================================
--- /issuevalue/src/test/java/geniusweb/issuevalue/NumberValueTest.java	(revision 33)
+++ /issuevalue/src/test/java/geniusweb/issuevalue/NumberValueTest.java	(revision 34)
@@ -7,5 +7,4 @@
 import java.util.ArrayList;
 import java.util.Arrays;
-import java.util.LinkedList;
 import java.util.List;
 
@@ -20,18 +19,17 @@
 
 public class NumberValueTest extends GeneralTests<NumberValue> {
-	private NumberValue value = new NumberValue("12.31");
-	private NumberValue value1 = new NumberValue("12.31");
-	private NumberValue valueb = new NumberValue("12.310000000000000001");
-	private String serialized = "12.31";
+	private final NumberValue value = new NumberValue("12.31");
+	private final NumberValue value1 = new NumberValue("12.31");
+	private final NumberValue valueb = new NumberValue("12.310000000000000001");
+	private final String serialized = "12.31";
 
-	private String bigserialized = "8748703924870439218876954320948372058";
-	private NumberValue bigvalue = new NumberValue(bigserialized);
+	private final String bigserialized = "8748703924870439218876954320948372058";
+	private final NumberValue bigvalue = new NumberValue(bigserialized);
+	private static final ObjectMapper jackson = new ObjectMapper();
 
 	@Override
 	public List<List<NumberValue>> getGeneralTestData() {
-		List<List<NumberValue>> list = new LinkedList<>();
-		list.add(Arrays.asList(value, value1));
-		list.add(Arrays.asList(valueb));
-		return list;
+		return Arrays.asList(Arrays.asList(value, value1),
+				Arrays.asList(valueb));
 	}
 
@@ -43,5 +41,4 @@
 	@Test
 	public void testSerialize() throws JsonProcessingException {
-		ObjectMapper jackson = new ObjectMapper();
 		assertEquals(serialized, jackson.writeValueAsString(value));
 	}
@@ -49,5 +46,4 @@
 	@Test
 	public void testDeserialize() throws IOException {
-		ObjectMapper jackson = new ObjectMapper();
 		assertEquals(value, jackson.readValue(serialized, NumberValue.class));
 
@@ -56,5 +52,4 @@
 	@Test
 	public void testDeserializeFromValue() throws IOException {
-		ObjectMapper jackson = new ObjectMapper();
 		assertEquals(value, jackson.readValue(serialized, Value.class));
 
@@ -63,5 +58,4 @@
 	@Test
 	public void testBigSerialize() throws JsonProcessingException {
-		ObjectMapper jackson = new ObjectMapper();
 		assertEquals(bigserialized, jackson.writeValueAsString(bigvalue));
 	}
@@ -69,5 +63,4 @@
 	@Test
 	public void testBigDeserialize() throws IOException {
-		ObjectMapper jackson = new ObjectMapper();
 		assertEquals(bigvalue,
 				jackson.readValue(bigserialized, NumberValue.class));
@@ -77,5 +70,4 @@
 	@Test
 	public void testSerializeShorts() throws IOException {
-		ObjectMapper jackson = new ObjectMapper();
 		System.out.println(
 				jackson.writeValueAsString(new short[] { 1, 2, 3, 4, 5 }));
@@ -85,5 +77,4 @@
 	@Test
 	public void testDeserializeShorts() throws IOException {
-		ObjectMapper jackson = new ObjectMapper();
 		@SuppressWarnings("unchecked")
 		ArrayList<Integer> list = jackson.readValue("[1,2,3,4,5]",
@@ -96,5 +87,4 @@
 	@Test
 	public void testDeserializeMix() throws IOException {
-		ObjectMapper jackson = new ObjectMapper();
 		@SuppressWarnings("unchecked")
 		ArrayList<Object> list = jackson.readValue("[\"short\",1,2,3,4,5]",
@@ -112,5 +102,4 @@
 	public void testDeserializePlainNumber()
 			throws JsonParseException, JsonMappingException, IOException {
-		ObjectMapper jackson = new ObjectMapper();
 		String valstr = "483958743698732691487326987569213874694328974329874328947320984372498327493827432987231874681273648127";
 		BigDecimal val = jackson.readValue(valstr, BigDecimal.class);
@@ -120,5 +109,4 @@
 	@Test
 	public void testNumberBlab() throws IOException {
-		ObjectMapper jackson = new ObjectMapper();
 		// jackson.enable(DeserializationFeature.USE_BIG_DECIMAL_FOR_FLOATS);
 		assertEquals(value, jackson.readValue("12.31", Value.class));
@@ -129,5 +117,4 @@
 	public void testDeserializeScientificNotation()
 			throws JsonParseException, JsonMappingException, IOException {
-		ObjectMapper jackson = new ObjectMapper();
 		String valstr = "9E+2";
 		Value val = jackson.readValue(valstr, Value.class);
Index: /opponentmodel/src/main/java/geniusweb/opponentmodel/FrequencyOpponentModel.java
===================================================================
--- /opponentmodel/src/main/java/geniusweb/opponentmodel/FrequencyOpponentModel.java	(revision 33)
+++ /opponentmodel/src/main/java/geniusweb/opponentmodel/FrequencyOpponentModel.java	(revision 34)
@@ -16,4 +16,5 @@
 import geniusweb.profile.utilityspace.UtilitySpace;
 import geniusweb.progress.Progress;
+import geniusweb.references.Parameters;
 
 /**
@@ -31,6 +32,4 @@
 
 	private static final int DECIMALS = 4; // accuracy of our computations.
-	private static int serial = 1; // counter for auto name generation
-
 	private final Domain domain;
 	private final Map<String, Map<Value, Integer>> bidFrequencies;
@@ -71,13 +70,13 @@
 
 	@Override
-	public FrequencyOpponentModel with(Domain domain, Bid resBid) {
-		if (domain == null) {
+	public FrequencyOpponentModel with(Domain newDomain, Bid newResBid) {
+		if (newDomain == null) {
 			throw new NullPointerException("domain is not initialized");
 		}
 		// FIXME merge already available frequencies?
-		return new FrequencyOpponentModel(domain,
-				domain.getIssues().stream().collect(
+		return new FrequencyOpponentModel(newDomain,
+				newDomain.getIssues().stream().collect(
 						Collectors.toMap(iss -> iss, iss -> new HashMap<>())),
-				BigDecimal.ZERO, resBid);
+				BigDecimal.ZERO, newResBid);
 	}
 
@@ -106,5 +105,5 @@
 			throw new IllegalStateException("domain is not initialized");
 		}
-		return "FreqOppModel" + (serial++) + "For" + domain;
+		return "FreqOppModel" + this.hashCode() + "For" + domain;
 	}
 
@@ -158,4 +157,9 @@
 	}
 
+	@Override
+	public OpponentModel with(Parameters parameters) {
+		return this; // ignore parameters
+	}
+
 	/**
 	 * 
Index: /opponentmodel/src/main/java/geniusweb/opponentmodel/OpponentModel.java
===================================================================
--- /opponentmodel/src/main/java/geniusweb/opponentmodel/OpponentModel.java	(revision 33)
+++ /opponentmodel/src/main/java/geniusweb/opponentmodel/OpponentModel.java	(revision 34)
@@ -7,4 +7,5 @@
 import geniusweb.profile.utilityspace.UtilitySpace;
 import geniusweb.progress.Progress;
+import geniusweb.references.Parameters;
 
 /**
@@ -24,6 +25,6 @@
 	/**
 	 * Initializes the model. This function must be called first after
-	 * constructing an instance. It can also be called later, if there is a
-	 * change in the domain or resBid.
+	 * constructing an instance. It can also be called again later, if there is
+	 * a change in the domain or resBid.
 	 * <p>
 	 * This late-initialization is to support boa models that have late
@@ -37,4 +38,13 @@
 	 */
 	OpponentModel with(Domain domain, Bid resBid);
+
+	/**
+	 * 
+	 * @param parameters Opponent-model specific {@link Parameters}
+	 * @return an updated OpponentMode, with parameters used. Each
+	 *         implementation of OpponentModel is free to use parameters as it
+	 *         likes. For instance to set learning speed.
+	 */
+	OpponentModel with(Parameters parameters);
 
 	/**
